<template>
  <div class="popular">
    <div class="popular__title">
      <h2>Peliculas Populares</h2>
    </div>
    <div class="popular__grid">
      <div class="popular__grid-item" v-for="(movie, index) in movies" :key="index" :class="{ animado: index > 8 }">
        <img :src="`https://image.tmdb.org/t/p/original${movie.poster_path}`" :alt="movie.original_title">
        <router-link :to="`/movie/${movie.id}`">
          <div class="info">
            <div class="info__header">
              <span>{{ movie.original_language }}</span>
              <ion-icon name="warning-outline" v-if="movie.adult"></ion-icon>
              <ion-icon name="people-outline" v-else></ion-icon>
            </div>
            <div class="info__content">
              <h1>{{ movie.original_title }}</h1>
              <span>{{ movie.release_date }}</span>
              <p>{{ movie.overview }}</p>
            </div>
          </div>
        </router-link>
      </div>
    </div>
    <div class="popular__button">
      <button @click="this.addMovies">Ver Mas</button>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
//import HelloWorld from '@/components/HelloWorld.vue';
import ApiService from "../services/api.service";
import { onMounted } from "vue";
 
export default {
  name: 'Popular',
  components: {
  },
  mounted() {
    document.title = "Movies | Populares";
  },
  data() {
    return { 
      movies: [],
      page: 1,
    }
  },
  setup() {
    onMounted(() => {
      // EFECTO FADE AL HACER SCROLL
      let grid = document.querySelector(".popular__grid");
      let animado = grid.children;

      function mostrarScroll() {
        let scrollTop = document.documentElement.scrollTop;

        for(var i=0; i<animado.length; i++) {
          let alturaAnimado = animado[i].offsetTop;
          if(alturaAnimado - 1000 < scrollTop) {
            animado[i].style.opacity = 1;
            animado[i].classList.add("mostrarArriba");
          }
        }
      }

      window.addEventListener('scroll', mostrarScroll);
    })
  },
  async created() {
    const { data } = await ApiService.getPopular(this.page);
    this.movies = data.results;
  },
  methods: {
    async addMovies() {
      this.page ++;
      const { data } = await ApiService.getPopular(this.page);
      const newData = data.results;
      newData.map((new_movie) => {
        this.movies.push(new_movie);
      })
    }
  }
}
</script>

<style lang="scss">
.popular {
  padding: 0 80px;

  @media (max-width: 900px) {
    padding: 0 20px;
  }

  &__title {
    margin: 20px 0;
    font-size: 14px;
  }

  &__grid {
    display: grid;
    grid-gap: 25px;
    gap: 25px;
    grid-template-columns: repeat(4, minmax(0, 1fr));

    @media (max-width: 900px) {
      grid-template-columns: repeat(3, minmax(0, 1fr));
    }

    @media (max-width: 768px) {
      grid-template-columns: repeat(2, minmax(0, 1fr));
    }

    @media (max-width: 600px) {
      grid-template-columns: repeat(1, minmax(0, 1fr));
    }

    &-item {
      box-shadow: 0 20px 50px rgba(0,0,0,.8);
      position: relative;

      img {
        opacity: 1;
        width: 100%;
        object-fit: cover;
        display: block;
        transition: all .4s;
        transform: translateY(0px);

        &:hover {
          transform: translateY(10px);
          cursor: pointer;
          box-shadow: 0px 20px 35px -16px rgba(255, 159, 16, 0.801); 
        }
      }

      .info {
        position: absolute;
        bottom: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: rgba(0, 0, 0, 0.6);
        color: #ffffff;
        opacity: 0;
        transition: all .4s ease-in-out;
        padding: 10px;

        &:hover {
          opacity: 1;
          cursor: pointer;
        }

        &__header {
          display: flex;
          align-items: center;
          justify-content: space-between;

          span { 
            font-size: 10px;
            font-weight: 200;
          }
        }

        &__content {
          h1 {
            font-size: 18px;
            letter-spacing: .1rem;
          }

          span {
            font-size: 10px;
            font-weight: 200;
          }

          p {
            font-size: 14px;
            margin-top: 10px;
            font-weight: 400;
          }
        }
      }

    }

    .animado {
      opacity: 0;
      transition: all 0.5s;
    }

    .mostrarArriba {
      animation: mostrarArriba 1s;
    }

    @keyframes mostrarArriba {
      0% {
        transform: translateX(60px);
      }

      100% {
        transform: translateX(0);
      }
    }
  }

  &__button {
    margin: 20px 0;
    display: flex;
    justify-content: center;

    button {
      padding: 10px 40px;
      border: none;

      &:hover {
        cursor: pointer;
      }
    }
  }
}
</style>